Index: uspace/drv/nic/rtl8169/driver.c
===================================================================
--- uspace/drv/nic/rtl8169/driver.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/nic/rtl8169/driver.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -30,5 +30,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <align.h>
 #include <byteorder.h>
@@ -52,40 +51,40 @@
 FIBRIL_MUTEX_INITIALIZE(irq_reg_lock);
 
-static errno_t rtl8169_set_addr(ddf_fun_t *fun, const nic_address_t *addr);
-static errno_t rtl8169_get_device_info(ddf_fun_t *fun, nic_device_info_t *info);
-static errno_t rtl8169_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state);
-static errno_t rtl8169_get_operation_mode(ddf_fun_t *fun, int *speed,
+static int rtl8169_set_addr(ddf_fun_t *fun, const nic_address_t *addr);
+static int rtl8169_get_device_info(ddf_fun_t *fun, nic_device_info_t *info);
+static int rtl8169_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state);
+static int rtl8169_get_operation_mode(ddf_fun_t *fun, int *speed,
     nic_channel_mode_t *duplex, nic_role_t *role);
-static errno_t rtl8169_set_operation_mode(ddf_fun_t *fun, int speed,
+static int rtl8169_set_operation_mode(ddf_fun_t *fun, int speed,
     nic_channel_mode_t duplex, nic_role_t role);
-static errno_t rtl8169_pause_get(ddf_fun_t *fun, nic_result_t *we_send, 
+static int rtl8169_pause_get(ddf_fun_t *fun, nic_result_t *we_send, 
     nic_result_t *we_receive, uint16_t *time);
-static errno_t rtl8169_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
+static int rtl8169_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
     uint16_t time);
-static errno_t rtl8169_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement);
-static errno_t rtl8169_autoneg_disable(ddf_fun_t *fun);
-static errno_t rtl8169_autoneg_probe(ddf_fun_t *fun, uint32_t *advertisement,
+static int rtl8169_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement);
+static int rtl8169_autoneg_disable(ddf_fun_t *fun);
+static int rtl8169_autoneg_probe(ddf_fun_t *fun, uint32_t *advertisement,
     uint32_t *their_adv, nic_result_t *result, nic_result_t *their_result);
-static errno_t rtl8169_autoneg_restart(ddf_fun_t *fun);
-static errno_t rtl8169_defective_get_mode(ddf_fun_t *fun, uint32_t *mode);
-static errno_t rtl8169_defective_set_mode(ddf_fun_t *fun, uint32_t mode);
-static errno_t rtl8169_on_activated(nic_t *nic_data);
-static errno_t rtl8169_on_stopped(nic_t *nic_data);
+static int rtl8169_autoneg_restart(ddf_fun_t *fun);
+static int rtl8169_defective_get_mode(ddf_fun_t *fun, uint32_t *mode);
+static int rtl8169_defective_set_mode(ddf_fun_t *fun, uint32_t mode);
+static int rtl8169_on_activated(nic_t *nic_data);
+static int rtl8169_on_stopped(nic_t *nic_data);
 static void rtl8169_send_frame(nic_t *nic_data, void *data, size_t size);
 static void rtl8169_irq_handler(ipc_call_t *icall, ddf_dev_t *dev);
-static inline errno_t rtl8169_register_int_handler(nic_t *nic_data, cap_handle_t *handle);
+static inline int rtl8169_register_int_handler(nic_t *nic_data);
 static inline void rtl8169_get_hwaddr(rtl8169_t *rtl8169, nic_address_t *addr);
 static inline void rtl8169_set_hwaddr(rtl8169_t *rtl8169, const nic_address_t *addr);
 
 static void rtl8169_reset(rtl8169_t *rtl8169);
-static errno_t rtl8169_get_resource_info(ddf_dev_t *dev);
-static errno_t rtl8169_fill_resource_info(ddf_dev_t *dev, const hw_res_list_parsed_t *hw_resources);
+static int rtl8169_get_resource_info(ddf_dev_t *dev);
+static int rtl8169_fill_resource_info(ddf_dev_t *dev, const hw_res_list_parsed_t *hw_resources);
 static rtl8169_t *rtl8169_create_dev_data(ddf_dev_t *dev);
 
-static errno_t rtl8169_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
+static int rtl8169_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
     const nic_address_t *, size_t);
-static errno_t rtl8169_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
+static int rtl8169_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
     const nic_address_t *addr, size_t addr_count);
-static errno_t rtl8169_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode);
+static int rtl8169_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode);
 
 static uint16_t rtl8169_mii_read(rtl8169_t *rtl8169, uint8_t addr);
@@ -161,5 +160,5 @@
 static ddf_dev_ops_t rtl8169_dev_ops;
 
-static errno_t rtl8169_dev_add(ddf_dev_t *dev);
+static int rtl8169_dev_add(ddf_dev_t *dev);
 
 /** Basic driver operations for RTL8169 driver */
@@ -174,5 +173,5 @@
 };
 
-static errno_t rtl8169_get_resource_info(ddf_dev_t *dev)
+static int rtl8169_get_resource_info(ddf_dev_t *dev)
 {
 	assert(dev);
@@ -185,10 +184,10 @@
 
 	/* Get hw resources form parent driver */
-	errno_t rc = nic_get_resources(nic_data, &hw_res_parsed);
+	int rc = nic_get_resources(nic_data, &hw_res_parsed);
 	if (rc != EOK)
 		return rc;
 
 	/* Fill resources information to the device */
-	errno_t ret = rtl8169_fill_resource_info(dev, &hw_res_parsed);
+	int ret = rtl8169_fill_resource_info(dev, &hw_res_parsed);
 	hw_res_list_parsed_clean(&hw_res_parsed);
 
@@ -196,5 +195,5 @@
 }
 
-static errno_t rtl8169_fill_resource_info(ddf_dev_t *dev, const hw_res_list_parsed_t
+static int rtl8169_fill_resource_info(ddf_dev_t *dev, const hw_res_list_parsed_t
     *hw_resources)
 {
@@ -229,7 +228,7 @@
 }
 
-static errno_t rtl8169_allocate_buffers(rtl8169_t *rtl8169)
-{
-	errno_t rc;
+static int rtl8169_allocate_buffers(rtl8169_t *rtl8169)
+{
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "Allocating DMA buffer rings");
@@ -334,7 +333,7 @@
 }
 
-static errno_t rtl8169_dev_initialize(ddf_dev_t *dev)
-{
-	errno_t ret;
+static int rtl8169_dev_initialize(ddf_dev_t *dev)
+{
+	int ret;
 
 	rtl8169_t *rtl8169 = rtl8169_create_dev_data(dev);
@@ -360,5 +359,5 @@
 }
 
-inline static errno_t rtl8169_register_int_handler(nic_t *nic_data, cap_handle_t *handle)
+inline static int rtl8169_register_int_handler(nic_t *nic_data)
 {
 	rtl8169_t *rtl8169 = nic_get_specific(nic_data);
@@ -368,15 +367,15 @@
 	rtl8169_irq_code.cmds[2].addr = rtl8169->regs + ISR;
 	rtl8169_irq_code.cmds[3].addr = rtl8169->regs + IMR;
-	errno_t rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
-	    rtl8169->irq, rtl8169_irq_handler, &rtl8169_irq_code, handle);
-
-	return rc;
-}
-
-static errno_t rtl8169_dev_add(ddf_dev_t *dev)
+	int irq_cap = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+	    rtl8169->irq, rtl8169_irq_handler, &rtl8169_irq_code);
+
+	return irq_cap;
+}
+
+static int rtl8169_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun;
 	nic_address_t nic_addr;
-	errno_t rc;
+	int rc;
 
 	assert(dev);
@@ -428,8 +427,8 @@
 		goto err_pio;
 
-	int irq_cap;
-	rc = rtl8169_register_int_handler(nic_data, &irq_cap);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed to register IRQ handler (%s)", str_error_name(rc));
+	int irq_cap = rtl8169_register_int_handler(nic_data);
+	if (irq_cap < 0) {
+		rc = irq_cap;
+		ddf_msg(LVL_ERROR, "Failed to register IRQ handler (%d)", rc);
 		goto err_irq;
 	}
@@ -481,9 +480,9 @@
 }
 
-static errno_t rtl8169_set_addr(ddf_fun_t *fun, const nic_address_t *addr)
+static int rtl8169_set_addr(ddf_fun_t *fun, const nic_address_t *addr)
 {
 	nic_t *nic_data = nic_get_from_ddf_fun(fun);
 	rtl8169_t *rtl8169 = nic_get_specific(nic_data);
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&rtl8169->rx_lock);
@@ -502,5 +501,5 @@
 }
 
-static errno_t rtl8169_get_device_info(ddf_fun_t *fun, nic_device_info_t *info)
+static int rtl8169_get_device_info(ddf_fun_t *fun, nic_device_info_t *info)
 {
 	nic_t *nic_data = nic_get_from_ddf_fun(fun);
@@ -528,5 +527,5 @@
 }
 
-static errno_t rtl8169_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
+static int rtl8169_get_cable_state(ddf_fun_t *fun, nic_cable_state_t *state)
 {
 	rtl8169_t *rtl8169 = nic_get_specific(nic_get_from_ddf_fun(fun));
@@ -541,5 +540,5 @@
 }
 
-static errno_t rtl8169_get_operation_mode(ddf_fun_t *fun, int *speed,
+static int rtl8169_get_operation_mode(ddf_fun_t *fun, int *speed,
     nic_channel_mode_t *duplex, nic_role_t *role)
 {
@@ -563,5 +562,5 @@
 }
 
-static errno_t rtl8169_set_operation_mode(ddf_fun_t *fun, int speed,
+static int rtl8169_set_operation_mode(ddf_fun_t *fun, int speed,
     nic_channel_mode_t duplex, nic_role_t role)
 {
@@ -594,5 +593,5 @@
 }
 
-static errno_t rtl8169_pause_get(ddf_fun_t *fun, nic_result_t *we_send, 
+static int rtl8169_pause_get(ddf_fun_t *fun, nic_result_t *we_send, 
     nic_result_t *we_receive, uint16_t *time)
 {
@@ -600,5 +599,5 @@
 }
 
-static errno_t rtl8169_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
+static int rtl8169_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
     uint16_t time)
 {
@@ -606,5 +605,5 @@
 }
 
-static errno_t rtl8169_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement)
+static int rtl8169_autoneg_enable(ddf_fun_t *fun, uint32_t advertisement)
 {
 	rtl8169_t *rtl8169 = nic_get_specific(nic_get_from_ddf_fun(fun));
@@ -630,5 +629,5 @@
 }
 
-static errno_t rtl8169_autoneg_disable(ddf_fun_t *fun)
+static int rtl8169_autoneg_disable(ddf_fun_t *fun)
 {
 	rtl8169_t *rtl8169 = nic_get_specific(nic_get_from_ddf_fun(fun));
@@ -641,5 +640,5 @@
 }
 
-static errno_t rtl8169_autoneg_probe(ddf_fun_t *fun, uint32_t *advertisement,
+static int rtl8169_autoneg_probe(ddf_fun_t *fun, uint32_t *advertisement,
     uint32_t *their_adv, nic_result_t *result, nic_result_t *their_result)
 {
@@ -647,5 +646,5 @@
 }
 
-static errno_t rtl8169_autoneg_restart(ddf_fun_t *fun)
+static int rtl8169_autoneg_restart(ddf_fun_t *fun)
 {
 	rtl8169_t *rtl8169 = nic_get_specific(nic_get_from_ddf_fun(fun));
@@ -657,10 +656,10 @@
 }
 
-static errno_t rtl8169_defective_get_mode(ddf_fun_t *fun, uint32_t *mode)
-{
-	return EOK;
-}
-
-static errno_t rtl8169_defective_set_mode(ddf_fun_t *fun, uint32_t mode)
+static int rtl8169_defective_get_mode(ddf_fun_t *fun, uint32_t *mode)
+{
+	return EOK;
+}
+
+static int rtl8169_defective_set_mode(ddf_fun_t *fun, uint32_t mode)
 {
 	return EOK;
@@ -691,7 +690,7 @@
 }
 
-static errno_t rtl8169_on_activated(nic_t *nic_data)
-{
-	errno_t rc;
+static int rtl8169_on_activated(nic_t *nic_data)
+{
+	int rc;
 	uint64_t tmp;
 
@@ -707,5 +706,5 @@
 	rc = rtl8169_allocate_buffers(rtl8169);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error allocating buffers: %s", str_error_name(rc));
+		ddf_msg(LVL_ERROR, "Error allocating buffers: %d", rc);
 		return 0;
 	}
@@ -753,5 +752,5 @@
 }
 
-static errno_t rtl8169_on_stopped(nic_t *nic_data)
+static int rtl8169_on_stopped(nic_t *nic_data)
 {
 	ddf_msg(LVL_NOTE, "Stopping device");
@@ -819,5 +818,5 @@
 }
 
-static errno_t rtl8169_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
+static int rtl8169_unicast_set(nic_t *nic_data, nic_unicast_mode_t mode,
     const nic_address_t *addr, size_t addr_count)
 {
@@ -871,5 +870,5 @@
 }
 
-static errno_t rtl8169_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
+static int rtl8169_multicast_set(nic_t *nic_data, nic_multicast_mode_t mode,
     const nic_address_t *addr, size_t addr_count)
 {
@@ -915,5 +914,5 @@
 }
 
-static errno_t rtl8169_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode)
+static int rtl8169_broadcast_set(nic_t *nic_data, nic_broadcast_mode_t mode)
 {
 	rtl8169_t *rtl8169 = nic_get_specific(nic_data);
@@ -1208,5 +1207,5 @@
 int main(void)
 {
-	errno_t rc = nic_driver_init(NAME);
+	int rc = nic_driver_init(NAME);
 	if (rc != EOK)
 		return rc;
Index: uspace/drv/platform/amdm37x/amdm37x.c
===================================================================
--- uspace/drv/platform/amdm37x/amdm37x.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/amdm37x/amdm37x.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,8 +53,8 @@
 
 
-errno_t amdm37x_init(amdm37x_t *device, bool trace)
+int amdm37x_init(amdm37x_t *device, bool trace)
 {
 	assert(device);
-	errno_t ret = EOK;
+	int ret = EOK;
 
 	ret = pio_enable((void*)USBHOST_CM_BASE_ADDRESS, USBHOST_CM_SIZE,
@@ -358,5 +358,5 @@
  * Select mode than can operate in FS/LS.
  */
-errno_t amdm37x_usb_tll_init(amdm37x_t *device)
+int amdm37x_usb_tll_init(amdm37x_t *device)
 {
 	/* Check access */
Index: uspace/drv/platform/amdm37x/amdm37x.h
===================================================================
--- uspace/drv/platform/amdm37x/amdm37x.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/amdm37x/amdm37x.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,6 +66,6 @@
 } amdm37x_t;
 
-errno_t amdm37x_init(amdm37x_t *device, bool trace_io);
-errno_t amdm37x_usb_tll_init(amdm37x_t *device);
+int amdm37x_init(amdm37x_t *device, bool trace_io);
+int amdm37x_usb_tll_init(amdm37x_t *device);
 void amdm37x_setup_dpll_on_autoidle(amdm37x_t *device);
 void amdm37x_usb_clocks_set(amdm37x_t *device, bool enabled);
Index: uspace/drv/platform/amdm37x/main.c
===================================================================
--- uspace/drv/platform/amdm37x/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/amdm37x/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,6 +49,5 @@
 typedef struct {
 	const char *name;
-	const char *id;
-	int score;
+	match_id_t match_id;
 	hw_resource_list_t hw_resources;
 } amdm37x_fun_t;
@@ -134,18 +133,15 @@
 {
 	.name = "ohci",
-	.id = "usb/host=ohci",
-	.score = 90,
+	.match_id = { .id = "usb/host=ohci", .score = 90 },
 	.hw_resources = { .resources = ohci_res, .count = ARRAY_SIZE(ohci_res) }
 },
 {
 	.name = "ehci",
-	.id = "usb/host=ehci",
-	.score = 90,
+	.match_id = { .id = "usb/host=ehci", .score = 90 },
 	.hw_resources = { .resources = ehci_res, .count = ARRAY_SIZE(ehci_res) }
 },
 {
 	.name = "fb",
-	.id = "amdm37x&dispc",
-	.score = 90,
+	.match_id = { .id = "amdm37x&dispc", .score = 90 },
 	.hw_resources = { .resources = disp_res, .count = ARRAY_SIZE(disp_res) }
 },
@@ -154,5 +150,5 @@
 
 static hw_resource_list_t *amdm37x_get_resources(ddf_fun_t *fnode);
-static errno_t amdm37x_enable_interrupt(ddf_fun_t *fun, int);
+static int amdm37x_enable_interrupt(ddf_fun_t *fun, int);
 
 static hw_res_ops_t fun_hw_res_ops = {
@@ -165,5 +161,5 @@
 };
 
-static errno_t amdm37x_add_fun(ddf_dev_t *dev, const amdm37x_fun_t *fun)
+static int amdm37x_add_fun(ddf_dev_t *dev, const amdm37x_fun_t *fun)
 {
 	assert(dev);
@@ -178,5 +174,6 @@
 	
 	/* Add match id */
-	errno_t ret = ddf_fun_add_match_id(fnode, fun->id, fun->score);
+	int ret = ddf_fun_add_match_id(fnode,
+	    fun->match_id.id, fun->match_id.score);
 	if (ret != EOK) {
 		ddf_fun_destroy(fnode);
@@ -212,8 +209,8 @@
  *            (both of HW and pseudo devices).
  *
- * @return Zero on success, error number otherwise.
- *
- */
-static errno_t amdm37x_dev_add(ddf_dev_t *dev)
+ * @return Zero on success, negative error number otherwise.
+ *
+ */
+static int amdm37x_dev_add(ddf_dev_t *dev)
 {
 	assert(dev);
@@ -221,5 +218,5 @@
 	if (!device)
 		return ENOMEM;
-	errno_t ret = amdm37x_init(device, DEBUG_CM);
+	int ret = amdm37x_init(device, DEBUG_CM);
 	if (ret != EOK) {
 		ddf_msg(LVL_FATAL, "Failed to setup hw access!.\n");
@@ -268,5 +265,5 @@
 }
 
-static errno_t amdm37x_enable_interrupt(ddf_fun_t *fun, int irq)
+static int amdm37x_enable_interrupt(ddf_fun_t *fun, int irq)
 {
 	//TODO: Implement
Index: uspace/drv/platform/icp/icp.c
===================================================================
--- uspace/drv/platform/icp/icp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/icp/icp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,5 +62,5 @@
 } icp_fun_t;
 
-static errno_t icp_dev_add(ddf_dev_t *dev);
+static int icp_dev_add(ddf_dev_t *dev);
 
 static driver_ops_t icp_ops = {
@@ -178,5 +178,5 @@
 }
 
-static errno_t icp_fun_enable_interrupt(ddf_fun_t *fnode, int irq)
+static int icp_fun_enable_interrupt(ddf_fun_t *fnode, int irq)
 {
 	icp_fun_t *fun = icp_fun(fnode);
@@ -188,5 +188,5 @@
 }
 
-static errno_t icp_fun_disable_interrupt(ddf_fun_t *fnode, int irq)
+static int icp_fun_disable_interrupt(ddf_fun_t *fnode, int irq)
 {
 	icp_fun_t *fun = icp_fun(fnode);
@@ -198,5 +198,5 @@
 }
 
-static errno_t icp_fun_clear_interrupt(ddf_fun_t *fnode, int irq)
+static int icp_fun_clear_interrupt(ddf_fun_t *fnode, int irq)
 {
 	icp_fun_t *fun = icp_fun(fnode);
@@ -231,5 +231,5 @@
 };
 
-static errno_t icp_add_fun(ddf_dev_t *dev, const char *name, const char *str_match_id,
+static int icp_add_fun(ddf_dev_t *dev, const char *name, const char *str_match_id,
     icp_fun_t *fun_proto)
 {
@@ -237,5 +237,5 @@
 
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 
 	/* Create new device. */
@@ -275,7 +275,7 @@
 }
 
-static errno_t icp_add_functions(ddf_dev_t *dev)
-{
-	errno_t rc;
+static int icp_add_functions(ddf_dev_t *dev)
+{
+	int rc;
 
 	rc = icp_add_fun(dev, "intctl", "integratorcp/intctl",
@@ -296,5 +296,5 @@
 
 /** Add device. */
-static errno_t icp_dev_add(ddf_dev_t *dev)
+static int icp_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_NOTE, "icp_dev_add, device handle = %d",
@@ -311,5 +311,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf(NAME ": HelenOS IntegratorCP platform driver\n");
Index: uspace/drv/platform/mac/mac.c
===================================================================
--- uspace/drv/platform/mac/mac.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/mac/mac.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -132,5 +132,5 @@
 	
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 	
 	/* Create new device. */
@@ -173,10 +173,10 @@
  *            (both of HW and pseudo devices).
  *
- * @return Zero on success, error number otherwise.
- *
- */
-static errno_t mac_dev_add(ddf_dev_t *dev)
-{
-	errno_t rc;
+ * @return Zero on success, negative error number otherwise.
+ *
+ */
+static int mac_dev_add(ddf_dev_t *dev)
+{
+	int rc;
 	uintptr_t cuda_physical;
 	sysarg_t cuda_inr;
@@ -227,5 +227,5 @@
 }
 
-static errno_t mac_enable_interrupt(ddf_fun_t *fun, int irq)
+static int mac_enable_interrupt(ddf_fun_t *fun, int irq)
 {
 	/* TODO */
Index: uspace/drv/platform/malta/malta.c
===================================================================
--- uspace/drv/platform/malta/malta.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/malta/malta.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -77,5 +77,5 @@
 } malta_fun_t;
 
-static errno_t malta_dev_add(ddf_dev_t *dev);
+static int malta_dev_add(ddf_dev_t *dev);
 static void malta_init(void);
 
@@ -143,5 +143,5 @@
 }
 
-static errno_t malta_enable_interrupt(ddf_fun_t *fun, int irq)
+static int malta_enable_interrupt(ddf_fun_t *fun, int irq)
 {
 	/* TODO */
@@ -177,5 +177,5 @@
 	
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 	
 	/* Create new device. */
@@ -221,11 +221,11 @@
  * @param dev		The device which is root of the whole device tree (both
  *			of HW and pseudo devices).
- * @return		Zero on success, error number otherwise.
- */
-static errno_t malta_dev_add(ddf_dev_t *dev)
+ * @return		Zero on success, negative error number otherwise.
+ */
+static int malta_dev_add(ddf_dev_t *dev)
 {
 	ioport32_t *gt;
 	uint32_t val;
-	errno_t ret;
+	int ret;
 
 	ddf_msg(LVL_DEBUG, "malta_dev_add, device handle = %d",
Index: uspace/drv/platform/msim/msim.c
===================================================================
--- uspace/drv/platform/msim/msim.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/msim/msim.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,5 +62,5 @@
 } msim_fun_t;
 
-static errno_t msim_dev_add(ddf_dev_t *dev);
+static int msim_dev_add(ddf_dev_t *dev);
 static void msim_init(void);
 
@@ -152,9 +152,9 @@
 }
 
-static errno_t msim_enable_interrupt(ddf_fun_t *fun, int irq)
+static int msim_enable_interrupt(ddf_fun_t *fun, int irq)
 {
 	/* Nothing to do. */
 
-	return EOK;
+	return true;
 }
 
@@ -186,5 +186,5 @@
 	
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 	
 	/* Create new device. */
@@ -238,5 +238,5 @@
  * @return Zero on success or non-zero error code.
  */
-static errno_t msim_dev_add(ddf_dev_t *dev)
+static int msim_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "msim_dev_add, device handle = %d",
Index: uspace/drv/platform/pc/pc.c
===================================================================
--- uspace/drv/platform/pc/pc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/pc/pc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -59,5 +59,5 @@
 } pc_fun_t;
 
-static errno_t pc_dev_add(ddf_dev_t *dev);
+static int pc_dev_add(ddf_dev_t *dev);
 static void pc_init(void);
 
@@ -125,5 +125,5 @@
 }
 
-static errno_t pc_enable_interrupt(ddf_fun_t *fun, int irq)
+static int pc_enable_interrupt(ddf_fun_t *fun, int irq)
 {
 	/* TODO */
@@ -159,5 +159,5 @@
 	
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 	
 	/* Create new device. */
@@ -203,7 +203,7 @@
  * @param dev		The device which is root of the whole device tree (both
  *			of HW and pseudo devices).
- * @return		Zero on success, error number otherwise.
- */
-static errno_t pc_dev_add(ddf_dev_t *dev)
+ * @return		Zero on success, negative error number otherwise.
+ */
+static int pc_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "pc_dev_add, device handle = %d",
Index: uspace/drv/platform/ski/ski.c
===================================================================
--- uspace/drv/platform/ski/ski.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/ski/ski.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,5 @@
 #define NAME "ski"
 
-static errno_t ski_dev_add(ddf_dev_t *dev);
+static int ski_dev_add(ddf_dev_t *dev);
 
 static driver_ops_t ski_ops = {
@@ -57,10 +57,10 @@
 };
 
-static errno_t ski_add_fun(ddf_dev_t *dev, const char *name, const char *str_match_id)
+static int ski_add_fun(ddf_dev_t *dev, const char *name, const char *str_match_id)
 {
 	ddf_msg(LVL_NOTE, "Adding function '%s'.", name);
 
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 
 	/* Create new device. */
@@ -94,7 +94,7 @@
 }
 
-static errno_t ski_add_functions(ddf_dev_t *dev)
+static int ski_add_functions(ddf_dev_t *dev)
 {
-	errno_t rc;
+	int rc;
 
 	rc = ski_add_fun(dev, "console", "ski/console");
@@ -106,5 +106,5 @@
 
 /** Add device. */
-static errno_t ski_dev_add(ddf_dev_t *dev)
+static int ski_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_NOTE, "ski_dev_add, device handle = %d",
@@ -121,5 +121,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf(NAME ": Ski platform driver\n");
Index: uspace/drv/platform/sun4u/sun4u.c
===================================================================
--- uspace/drv/platform/sun4u/sun4u.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/sun4u/sun4u.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -77,5 +77,5 @@
 } sun4u_fun_t;
 
-static errno_t sun4u_dev_add(ddf_dev_t *dev);
+static int sun4u_dev_add(ddf_dev_t *dev);
 static void sun4u_init(void);
 
@@ -159,5 +159,5 @@
 }
 
-static errno_t sun4u_enable_interrupt(ddf_fun_t *fun, int irq)
+static int sun4u_enable_interrupt(ddf_fun_t *fun, int irq)
 {
 	/* TODO */
@@ -193,5 +193,5 @@
 	
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 	
 	/* Create new device. */
@@ -240,7 +240,7 @@
  * @param dev		The device which is root of the whole device tree (both
  *			of HW and pseudo devices).
- * @return		Zero on success, error number otherwise.
- */
-static errno_t sun4u_dev_add(ddf_dev_t *dev)
+ * @return		Zero on success, negative error number otherwise.
+ */
+static int sun4u_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "sun4u_dev_add, device handle = %d",
Index: uspace/drv/platform/sun4v/sun4v.c
===================================================================
--- uspace/drv/platform/sun4v/sun4v.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/platform/sun4v/sun4v.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <ddf/log.h>
 #include <errno.h>
-#include <str_error.h>
 #include <ops/hw_res.h>
 #include <ops/pio_window.h>
@@ -55,5 +54,5 @@
 } sun4v_fun_t;
 
-static errno_t sun4v_dev_add(ddf_dev_t *dev);
+static int sun4v_dev_add(ddf_dev_t *dev);
 
 static driver_ops_t sun4v_ops = {
@@ -114,7 +113,7 @@
 }
 
-static errno_t sun4v_enable_interrupt(ddf_fun_t *fun, int irq)
-{
-	return EOK;
+static int sun4v_enable_interrupt(ddf_fun_t *fun, int irq)
+{
+	return true;
 }
 
@@ -138,5 +137,5 @@
 static ddf_dev_ops_t sun4v_fun_ops;
 
-static errno_t sun4v_add_fun(ddf_dev_t *dev, const char *name,
+static int sun4v_add_fun(ddf_dev_t *dev, const char *name,
     const char *str_match_id, sun4v_fun_t *fun_proto)
 {
@@ -144,5 +143,5 @@
 
 	ddf_fun_t *fnode = NULL;
-	errno_t rc;
+	int rc;
 
 	/* Create new device. */
@@ -188,7 +187,7 @@
 }
 
-static errno_t sun4v_add_functions(ddf_dev_t *dev)
-{
-	errno_t rc;
+static int sun4v_add_functions(ddf_dev_t *dev)
+{
+	int rc;
 
 	rc = sun4v_add_fun(dev, "console", "sun4v/console", &console_data);
@@ -200,5 +199,5 @@
 
 /** Add device. */
-static errno_t sun4v_dev_add(ddf_dev_t *dev)
+static int sun4v_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "sun4v_dev_add, device handle = %d",
@@ -213,7 +212,7 @@
 }
 
-static errno_t sun4v_init(void)
-{
-	errno_t rc;
+static int sun4v_init(void)
+{
+	int rc;
 	sysarg_t paddr;
 
@@ -229,5 +228,5 @@
 	rc = sysinfo_get_value("niagara.inbuf.address", &paddr);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "niagara.inbuf.address not set: %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "niagara.inbuf.address not set (%d)", rc);
 		return rc;
 	}
@@ -237,5 +236,5 @@
 	rc = sysinfo_get_value("niagara.outbuf.address", &paddr);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "niagara.outbuf.address not set: %s", str_error(rc));
+		ddf_msg(LVL_ERROR, "niagara.outbuf.address not set (%d)", rc);
 		return rc;
 	}
@@ -247,5 +246,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	printf(NAME ": Sun4v platform driver\n");
Index: uspace/drv/root/root/root.c
===================================================================
--- uspace/drv/root/root/root.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/root/root/root.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -64,7 +64,7 @@
 #define VIRTUAL_FUN_MATCH_SCORE 100
 
-static errno_t root_dev_add(ddf_dev_t *dev);
-static errno_t root_fun_online(ddf_fun_t *fun);
-static errno_t root_fun_offline(ddf_fun_t *fun);
+static int root_dev_add(ddf_dev_t *dev);
+static int root_fun_online(ddf_fun_t *fun);
+static int root_fun_offline(ddf_fun_t *fun);
 
 /** The root device driver's standard operations. */
@@ -84,11 +84,11 @@
  *
  * @param dev	Device
- * @return	EOK on success or an error code
- */
-static errno_t add_virtual_root_fun(ddf_dev_t *dev)
+ * @return	EOK on success or negative error code
+ */
+static int add_virtual_root_fun(ddf_dev_t *dev)
 {
 	const char *name = VIRTUAL_FUN_NAME;
 	ddf_fun_t *fun;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "Adding new function for virtual devices. "
@@ -125,7 +125,7 @@
  *
  * @param dev	Device
- * @return	EOK on success or an error code
- */
-static errno_t add_platform_fun(ddf_dev_t *dev)
+ * @return	EOK on success or negative error code
+ */
+static int add_platform_fun(ddf_dev_t *dev)
 {
 	char *match_id;
@@ -135,5 +135,5 @@
 	const char *name = PLATFORM_FUN_NAME;
 	ddf_fun_t *fun;
-	errno_t rc;
+	int rc;
 
 	/* Get platform name from sysinfo. */
@@ -201,5 +201,5 @@
  *			of HW and pseudo devices).
  */
-static errno_t root_dev_add(ddf_dev_t *dev)
+static int root_dev_add(ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "root_dev_add, device handle=%" PRIun,
@@ -211,5 +211,5 @@
 	 * vital for the system.
 	 */
-	errno_t res = add_virtual_root_fun(dev);
+	int res = add_virtual_root_fun(dev);
 	if (res != EOK)
 		ddf_msg(LVL_WARN, "Failed to add virtual child.");
@@ -223,5 +223,5 @@
 }
 
-static errno_t root_fun_online(ddf_fun_t *fun)
+static int root_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "root_fun_online()");
@@ -229,5 +229,5 @@
 }
 
-static errno_t root_fun_offline(ddf_fun_t *fun)
+static int root_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "root_fun_offline()");
Index: uspace/drv/root/virt/virt.c
===================================================================
--- uspace/drv/root/virt/virt.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/root/virt/virt.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,8 +62,8 @@
 };
 
-static errno_t virt_dev_add(ddf_dev_t *dev);
-static errno_t virt_dev_remove(ddf_dev_t *dev);
-static errno_t virt_fun_online(ddf_fun_t *fun);
-static errno_t virt_fun_offline(ddf_fun_t *fun);
+static int virt_dev_add(ddf_dev_t *dev);
+static int virt_dev_remove(ddf_dev_t *dev);
+static int virt_fun_online(ddf_fun_t *fun);
+static int virt_fun_offline(ddf_fun_t *fun);
 
 static driver_ops_t virt_ops = {
@@ -98,12 +98,12 @@
  * @param vdev		The virtual device
  * @param vfun		Virtual function description
- * @return		EOK on success or an error code.
- */
-static errno_t virt_add_fun(virt_t *virt, virtual_function_t *vfun)
+ * @return		EOK on success or negative error code.
+ */
+static int virt_add_fun(virt_t *virt, virtual_function_t *vfun)
 {
 	ddf_dev_t *vdev = virt->dev;
 	ddf_fun_t *fun;
 	virt_fun_t *rvfun;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "Registering function `%s' (match \"%s\")",
@@ -148,7 +148,7 @@
 }
 
-static errno_t virt_fun_remove(virt_fun_t *rvfun)
-{
-	errno_t rc;
+static int virt_fun_remove(virt_fun_t *rvfun)
+{
+	int rc;
 	const char *name = ddf_fun_get_name(rvfun->fun);
 
@@ -172,5 +172,5 @@
 
 
-static errno_t virt_dev_add(ddf_dev_t *dev)
+static int virt_dev_add(ddf_dev_t *dev)
 {
 	virt_t *virt;
@@ -205,8 +205,8 @@
 }
 
-static errno_t virt_dev_remove(ddf_dev_t *dev)
+static int virt_dev_remove(ddf_dev_t *dev)
 {
 	virt_t *virt = (virt_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	while (!list_empty(&virt->functions)) {
@@ -224,5 +224,5 @@
 }
 
-static errno_t virt_fun_online(ddf_fun_t *fun)
+static int virt_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "virt_fun_online()");
@@ -230,5 +230,5 @@
 }
 
-static errno_t virt_fun_offline(ddf_fun_t *fun)
+static int virt_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "virt_fun_offline()");
